Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 516240 - www-servers/apache USE=ssl with SYMLINK_LIB=no LIBDIR_x86=lib - /usr/lib/libdb-4.8.so: could not read symbols: File in wrong format
Summary: www-servers/apache USE=ssl with SYMLINK_LIB=no LIBDIR_x86=lib - /usr/lib/libd...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] Server (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Lars Wendler (Polynomial-C)
URL:
Whiteboard:
Keywords: PATCH
Depends on:
Blocks: no-symlink-lib
  Show dependency tree
 
Reported: 2014-07-03 22:02 UTC by Alexander Tsoy
Modified: 2016-12-28 08:11 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (apache-build.log,233.79 KB, text/plain)
2014-07-03 22:02 UTC, Alexander Tsoy
Details
apache-tools-2.2.27.ebuild.patch (apache-tools-2.2.27.ebuild.patch,789 bytes, patch)
2014-07-03 22:03 UTC, Alexander Tsoy
Details | Diff
apache-2.2.27.ebuild.patch (apache-2.2.27.ebuild.patch,703 bytes, patch)
2014-07-03 22:15 UTC, Alexander Tsoy
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Alexander Tsoy 2014-07-03 22:02:36 UTC
Created attachment 380138 [details]
build.log

Build system adds "-L/usr/lib" to LDFLAGS, so linkage breaks on systems with SYMLINK_LIB=no LIBDIR_x86=lib and multilib. Build succeeds with USE=-ssl.


$ emerge --info www-servers/apache
Portage 2.2.8-r1 (hardened/linux/amd64, gcc-4.7.3, glibc-2.17, 3.14.9-hardened x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-3.14.9-hardened-x86_64-AMD_Opteron-tm-_Processor_4332_HE-with-gentoo-2.2
KiB Mem:    16411776 total,  13719112 free
KiB Swap:   16777212 total,  16777212 free
Timestamp of tree: Thu, 03 Jul 2014 00:45:01 +0000
ld GNU ld (GNU Binutils) 2.23.2
app-shells/bash:          4.2_p45
dev-java/java-config:     2.2.0
dev-lang/python:          2.7.6, 3.3.3
dev-util/cmake:           2.8.12.2
dev-util/pkgconfig:       0.28-r1
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.12.4
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.11.6, 1.12.6, 1.13.4
sys-devel/binutils:       2.23.2
sys-devel/gcc:            4.7.3-r1
sys-devel/gcc-config:     1.7.3
sys-devel/libtool:        2.4.2-r1
sys-devel/make:           3.82-r4
sys-kernel/linux-headers: 3.13 (virtual/os-headers)
sys-libs/glibc:           2.17
Repositories: gentoo puleglot local
ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -march=bdver2 -mtune=bdver2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/easy-rsa /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -march=bdver2 -mtune=bdver2 -pipe"
DISTDIR="/var/cache/portage/distfiles"
EMERGE_DEFAULT_OPTS="--with-bdeps=y --binpkg-respect-use=y --ask-enter-invalid"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs buildsyspkg config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync webrsync-gpg xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://mirror.yandex.ru/gentoo-distfiles/ ftp://mirror.yandex.ru/gentoo-distfiles/"
LANG="ru_RU.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j6"
PKGDIR="/var/cache/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/var/cache/portage/tree"
PORTDIR_OVERLAY="/var/lib/layman/puleglot-overlay /usr/local/portage"
SYNC=""
USE="X aac acl acpi aio alsa amd64 amr ape asyncns avahi avx bash-completion berkdb bluetooth bluray branding bzip2 cairo caps cdda cddb cdparanoia cdr cli colord cracklib crypt cryptsetup cups cxx dbus dconf device-mapper djvu dri dts dvd dvdr eds egl evo examples exif faac faad ffmpeg flac fma fontconfig fuse gdbm gif gnome gnome-keyring gnome-online-accounts gpm gstreamer gtk gtk3 hardened iconv icu idn ieee1394 introspection ipv6 jit jpeg jpeg2k justify libass libnotify libsamplerate libsecret lz4 lzma mac mad maildir mms mmx mmxext modules mp3 mp4 multilib musepack musicbrainz nautilus ncurses networkmanager nls nptl nptlonly ogg openal opengl openmp opus pam pax_kernel pcre perl pmu png policykit postscript pulseaudio python raw readline samba sasl session socialweb speex sse sse2 sse3 sse4 sse4_1 sse4a ssl ssse3 startup-notification svg systemd tcpd theora tiff tls truetype udev unicode upnp-av urandom usb vdpau vim-syntax vorbis vpx wavpack webp x264 xattr xfs xtpax xv xvid xz zlib" ABI_X86="64 32" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="*" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="pc" INPUT_DEVICES="evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en ru" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_3" QEMU_SOFTMMU_TARGETS="aarch64 arm i386 mips mips64 mips64el mipsel ppc ppc64 ppcemb x86_64" RUBY_TARGETS="ruby19 ruby20" USERLAND="GNU" VIDEO_CARDS="radeon radeonsi modesetting vesa v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON

=================================================================
                        Package Settings
=================================================================

www-servers/apache-2.2.27 was built with the following:
USE="-debug -doc -ldap (-selinux) -ssl -static -suexec -threads" ABI_X86="64" APACHE2_MODULES="actions alias auth_basic auth_digest authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias -asis -authn_dbd -cern_meta -charset_lite -dbd -dumpio -ident -imagemap -log_forensic -proxy -proxy_ajp -proxy_balancer -proxy_connect -proxy_ftp -proxy_http -proxy_scgi -reqtimeout -substitute -version" APACHE2_MPMS="-event -itk -peruser -prefork -worker"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,--no-as-needed"
Comment 1 Alexander Tsoy 2014-07-03 22:03:35 UTC
Created attachment 380140 [details, diff]
apache-tools-2.2.27.ebuild.patch

Quick fix
Comment 2 Alexander Tsoy 2014-07-03 22:15:05 UTC
Created attachment 380146 [details, diff]
apache-2.2.27.ebuild.patch

Quick fix
Comment 3 Mike Gilbert gentoo-dev 2014-07-25 02:41:20 UTC
A similar error occurs in the 2.4 branch, but requires a different fix due to build system changes.
Comment 4 Steven Newbury 2016-12-17 23:27:09 UTC
Am I the only one who uses SYMLINK_LIB=no?

This is still broken.  As far as I can tell, the only change needed is the below chunk to apache-2.eclass:

@@ -270,7 +270,7 @@
 	fi
 
 	if use ssl ; then
-		MY_CONF+=( --with-ssl="${EPREFIX}"/usr --enable-ssl=${mod_type} )
+		MY_CONF+=( --with-ssl --enable-ssl=${mod_type} )
 		MY_MODS+=( ssl )
 	else
 		MY_CONF+=( --without-ssl --disable-ssl )


When --with-ssl="${EPREFIX}"/usr is used the configure script reads the OpenSSL pkgconfig file from /usr/lib/pkgconfig because it interprets the "/usr" to be a "stand-alone install" prefix with no handling for a system prefix which is of course what is being specified.

I've been using this in my multilib fixes overlay for the last few years without issue.
Comment 5 SpanKY gentoo-dev 2016-12-28 08:11:25 UTC
(In reply to Steven Newbury from comment #4)

you're obviously not the only one that uses SYMLINK_LIB=no.  but if you read the bug, it's also obvious that simply running that setup is not sufficient to trigger this bug.  you have to (1) have SYMLINK_LIB=no (2) run a multilib setup (3) have multilib builds of both openssl and db and (4) build apache with USE=ssl.

i've been building apache for a long time w/SYMLINK_LIB=no, but i don't have a lot of x86 multilib installs because i don't need them.

i've pushed your patch here:
https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=f3bcb27dfa43b87e8e67f8cc23f16816630b563c

thanks!